#lang "qb"
' Palancola su terreno stratificato
' Software scritto dal prof. Arnold Verruijt
' dalla Delft University of Technology
' reperibile in questa dispensa http://geo.verruijt.net/software/SoilMechBook2012.pdf
' Tradotto e leggermente modificato da Nicola Rainiero
'##########################
'# rainnic.altervista.org #
'##########################
100 CLS:PRINT"Palancola su terreno stratificato":NN=1000
110 PRINT"Modello Blum":PRINT
120 DIM D(20),Z(20),CA(20),CP(20)
130 DIM CC(20),GDL(20),GNL(20),WL(20),GDR(20),GNR(20),WR(20)
140 DIM M(NN),Q(NN),F(NN),P(NN),U(NN)
150 INPUT "Profondita' ancoraggio (m) .............. ";DA
152 INPUT "Lunghezza palo Ia ipotesi................. ";HIP1
155 INPUT "Lunghezza palo IIa ipotesi................. ";HIP2
157 INPUT "Lunghezza palo IIIa ipotesi................. ";HIP3
160 INPUT "Numero degli strati ................. ";N
170 Z(0)=0:GW=10:FOR I=1 TO N:CLS:PRINT "Strato ";I:PRINT
180 INPUT "Spessore (m) .................... ";D(I)
190 INPUT "Coesione (kN/m2) ................. ";CC(I)
200 INPUT "Spinta attiva ................ ";CA(I)
210 INPUT "Spinta passiva ............... ";CP(I)
220 INPUT "Peso secco a sinistra (kN/m3) .......... ";GDL(I)
230 INPUT "Peso saturo a sinistra (kN/m3) .... ";GNL(I)
240 INPUT "Profondita' della falda a sinistra (m) .... ";WL(I)
250 INPUT "Peso secco a destra (kN/m3) ......... ";GDR(I)
260 INPUT "Peso saturo a destra (kN/m3) ... ";GNR(I)
270 INPUT "Profondita' della falda a destra (m) ... ";WR(I)
280 Z(I)=Z(I-1)+D(I):NEXT I
290 HH=Z(N):DZ=HH/NN:DZ2=DZ/2:TLZ=0:TRZ=0:J=1:ZZ=0
300 FOR I=1 TO NN:ZZ=ZZ+DZ:IF ZZ>Z(J) THEN J=J+1
310 IF ZZ<WL(J) THEN GL=GDL(J) ELSE GL=GNL(J)
320 IF ZZ<WR(J) THEN GR=GDR(J) ELSE GR=GNR(J)
330 IF ZZ<WL(J) THEN PL=0 ELSE PL=GW*(ZZ-WL(J))
340 IF ZZ<WR(J) THEN PR=0 ELSE PR=GW*(ZZ-WR(J))
350 TLZ=TLZ+DZ*GL:SLZ=TLZ-PL:TRZ=TRZ+DZ*GR:SRZ=TRZ-PR
360 SLX=CP(J)*SLZ+2*CC(J)*SQR(CP(J))
370 SRX=CA(J)*SRZ-2*CC(J)*SQR(CA(J)):IF SRX<0 THEN SRX=0
380 TLX=SLX+PL:TRX=SRX+PR:F(I)=TRX-TLX:NEXT I
390 F(0)=0:Q(0)=0:M(0)=0:JJ=0:FOR I=1 TO NN
400 FF=(F(I)+F(I-1))*DZ2:IF I*DZ<DA THEN JJ=I
410 Q(I)=Q(I-1)-FF:M(I)=M(I-1)+(Q(I)+Q(I-1))*DZ2
420 NEXT I:NH=NN+1:UA=1:WHILE UA>0:NH=NH-1
430 HT=NH*DZ:T=-M(NH)/(HT-DA):P(NH)=0:U(NH)=0
440 FOR I=NH-1 TO JJ STEP -1:M1=M(I)+T*(I*DZ-DA)
450 M2=M(I+1)+T*(I*DZ+DZ-DA):P(I)=P(I+1)+M1+M2
460 U(I)=U(I+1)-P(I)-P(I+1):NEXT I:UA=U(JJ)
470 WEND:NH=NH+1:HT=NH*DZ:T=-M(NH)/(HT-DA):A$="####.###"
480 FOR I=JJ TO NH:Q(I)=Q(I)+T:M(I)=M(I)+T*(I*DZ-DA)
485 IF (M(I)>MM) THEN MM=M(I):ZMAX=I*DZ
486 'IF (M(I)>MM) THEN ZMAX=I*DZ
487 NEXT I
488 CLS:PRINT " "
489 PRINT "********* SOLUZIONE PER PALO OTTIMIZZATO *********"
490 PRINT " "
495 PRINT"Lunghezza palo ottimizzato (m): ";:PRINT USING A$;HT
500 PRINT"Forza ancoraggio (kN): ";:PRINT USING A$;T
510 PRINT "Momento massimo (kNm/m) ........... ";:PRINT USING A$;MM
515 PRINT "Profondita' Mmax (m) ........... ";:PRINT USING A$;ZMAX
520 PRINT "Forza di taglio al piede ........... ";:PRINT USING A$;Q(NH)
530 PRINT "Momento al piede ................ ";:PRINT USING A$;M(NH)
550 '*****************
560 HH=Z(N)
570 DZ=HH/NN
580 DZ2=DZ/2
590 TLZ=0
600 TRZ=0
610 J=1
620 ZZ=0
630 '*****************
640 FOR I=1 TO NN
650 ZZ=ZZ+DZ
660 IF ZZ>Z(J) THEN J=J+1
670 IF ZZ<WL(J) THEN GL=GDL(J) ELSE GL=GNL(J)
680 IF ZZ<WR(J) THEN GR=GDR(J) ELSE GR=GNR(J)
690 IF ZZ<WL(J) THEN PL=0 ELSE PL=GW*(ZZ-WL(J))
700 IF ZZ<WR(J) THEN PR=0 ELSE PR=GW*(ZZ-WR(J))
710 TLZ=TLZ+DZ*GL
720 SLZ=TLZ-PL
730 TRZ=TRZ+DZ*GR
740 SRZ=TRZ-PR
750 SLX=CP(J)*SLZ+2*CC(J)*SQR(CP(J))
760 SRX=CA(J)*SRZ-2*CC(J)*SQR(CA(J))
770 IF SRX<0 THEN SRX=0
780 TLX=SLX+PL
790 TRX=SRX+PR
800 F(I)=TRX-TLX
810 NEXT I
820 '*****************
830 F(0)=0
840 Q(0)=0
850 M(0)=0
860 JJ=0
870 '*****************
880 FOR I=1 TO NN
890 FF=(F(I)+F(I-1))*DZ2
900 IF I*DZ<DA THEN JJ=I
910 Q(I)=Q(I-1)-FF
920 M(I)=M(I-1)+(Q(I)+Q(I-1))*DZ2
930 NEXT I
940 '*****************
950 NH=NN+1
960 UA=1
970 '*****************
980 WHILE UA>0
1000 NH=NH-1
1010 HT=NH*DZ
1020 T=-M(NH)/(HT-DA)
1030 P(NH)=0:U(NH)=0
1040 FOR I=NH-1 TO JJ STEP -1
1050 M1=M(I)+T*(I*DZ-DA)
1060 M2=M(I+1)+T*(I*DZ+DZ-DA)
1070 P(I)=P(I+1)+M1+M2
1080 U(I)=U(I+1)-P(I)-P(I+1)
1090 NEXT I:UA=U(JJ)
1100 WEND
1110 '***************** PALO DA IPOTESI HIP1
1120 'NH=NH+1
1125 NH=HIP1/DZ
1130 HT=NH*DZ
1140 T=-M(NH)/(HT-DA)
1150 '*****************
1160 FOR I=JJ TO NH
1170 Q(I)=Q(I)+T
1180 M(I)=M(I)+T*(I*DZ-DA)
1190 IF (M(I)>MM) THEN MM=M(I):ZMAX=I*DZ
1200 'IF (M(I)>MM) THEN ZMAX=I*DZ
1210 NEXT I
1220 '*****************
1221 PRINT " "
1222 PRINT "********* SOLUZIONE PER PALO Ia IPOTESI *********"
1223 PRINT " "
1230 PRINT"Lunghezza palo Ia ipotesi (m): ";:PRINT USING A$;HT
1240 PRINT"Forza ancoraggio (kN): ";:PRINT USING A$;T
1250 PRINT "Momento massimo (kNm/m) ........... ";:PRINT USING A$;MM
1260 PRINT "Profondita' Mmax (m) ........... ";:PRINT USING A$;ZMAX
1270 PRINT "Forza di taglio al piede ........... ";:PRINT USING A$;Q(NH)
1280 PRINT "Momento al piede ................ ";:PRINT USING A$;M(NH)
1290 INPUT "PREMERE PER CONTINUARE";S
'***************** PALO DA IPOTESI HIP2
1300 'NH=NH+1
1310 NH=HIP2/DZ
1320 HT=NH*DZ
1330 T=-M(NH)/(HT-DA)
1340 '*****************
1350 FOR I=JJ TO NH
1360 Q(I)=Q(I)+T
1370 M(I)=M(I)+T*(I*DZ-DA)
1380 IF (M(I)>MM) THEN MM=M(I):ZMAX=I*DZ
1390 'IF (M(I)>MM) THEN ZMAX=I*DZ
1400 NEXT I
1410 '*****************
1420 PRINT " "
1430 PRINT "********* SOLUZIONE PER PALO IIa IPOTESI *********"
1440 PRINT " "
1450 PRINT"Lunghezza palo IIa ipotesi (m): ";:PRINT USING A$;HT
1460 PRINT"Forza ancoraggio (kN): ";:PRINT USING A$;T
1470 PRINT "Momento massimo (kNm/m) ........... ";:PRINT USING A$;MM
1480 PRINT "Profondita' Mmax (m) ........... ";:PRINT USING A$;ZMAX
1490 PRINT "Forza di taglio al piede ........... ";:PRINT USING A$;Q(NH)
1500 PRINT "Momento al piede ................ ";:PRINT USING A$;M(NH)
1510 INPUT "PREMERE PER CONTINUARE";S
1520 '***************** PALO DA IPOTESI HIP3
1530 'NH=NH+1
1540 NH=HIP3/DZ
1550 HT=NH*DZ
1560 T=-M(NH)/(HT-DA)
1570 '*****************
1580 FOR I=JJ TO NH
1590 Q(I)=Q(I)+T
1600 M(I)=M(I)+T*(I*DZ-DA)
1610 IF (M(I)>MM) THEN MM=M(I):ZMAX=I*DZ
1620 'IF (M(I)>MM) THEN ZMAX=I*DZ
1630 NEXT I
1640 '*****************
1650 PRINT " "
1660 PRINT "********* SOLUZIONE PER PALO IIIa IPOTESI *********"
1670 PRINT " "
1680 PRINT"Lunghezza palo IIIa ipotesi (m): ";:PRINT USING A$;HT
1690 PRINT"Forza ancoraggio (kN): ";:PRINT USING A$;T
1700 PRINT "Momento massimo (kNm/m) ........... ";:PRINT USING A$;MM
1710 PRINT "Profondita' Mmax (m) ........... ";:PRINT USING A$;ZMAX
1720 PRINT "Forza di taglio al piede ........... ";:PRINT USING A$;Q(NH)
1730 PRINT "Momento al piede ................ ";:PRINT USING A$;M(NH)
1740 INPUT "PREMERE PER CONTINUARE";S
1750 INPUT "PREMERE PER USCIRE";S
1760 END
